import{s as dt,n as mt,o as lt}from"../chunks/scheduler.0f20f9e5.js";import{S as pt,i as ct,g as r,s as i,r as m,A as bt,h as d,f as t,c as n,j as g,u as l,x as z,k as h,y as o,a as s,v as p,d as c,t as b,w as _}from"../chunks/index.fbd8b8e3.js";import{D as f}from"../chunks/Docstring.8771d8c5.js";import{H as ee}from"../chunks/Heading.2451f3bb.js";function _t(Ye){let u,me,re,le,L,pe,N,Ze='<a href="https://hf.co/papers/1412.6980" rel="nofollow">Adam (Adaptive moment estimation)</a> is an adaptive learning rate optimizer, combining ideas from <code>SGD</code> with momentum and <code>RMSprop</code> to automatically scale the learning rate:',ce,W,et="<li>a weighted average of the past gradients to provide direction (first-moment)</li> <li>a weighted average of the <em>squared</em> past gradients to adapt the learning rate to each parameter (second-moment)</li>",be,q,tt="bitsandbytes also supports paged optimizers which take advantage of CUDAs unified memory to transfer memory from the GPU to the CPU when GPU memory is exhausted.",_e,E,ge,v,M,Se,T,I,Ge,te,at="Base Adam optimizer.",he,V,fe,y,S,He,P,G,Ue,ae,it="8-bit Adam optimizer.",ue,H,ve,$,U,Re,k,R,je,ie,nt="32-bit Adam optimizer.",ye,j,$e,A,B,Be,F,J,Je,ne,st="Paged Adam optimizer.",Ae,K,xe,x,O,Ke,D,Q,Oe,se,ot="8-bit paged Adam optimizer.",we,X,ze,w,Y,Qe,C,Z,Xe,oe,rt="Paged 32-bit Adam optimizer.",Te,de,Pe;return L=new ee({props:{title:"Adam",local:"adam",headingTag:"h1"}}),E=new ee({props:{title:"Adam",local:"api-class ][ bitsandbytes.optim.Adam",headingTag:"h2"}}),M=new f({props:{name:"class bitsandbytes.optim.Adam",anchor:"bitsandbytes.optim.Adam",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L16"}}),I=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Adam.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adam.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adam.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adam.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Adam.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adam.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adam.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.Adam.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adam.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adam.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adam.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adam.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Adam.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L17"}}),V=new ee({props:{title:"Adam8bit",local:"bitsandbytes.optim.Adam8bit",headingTag:"h2"}}),S=new f({props:{name:"class bitsandbytes.optim.Adam8bit",anchor:"bitsandbytes.optim.Adam8bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L50"}}),G=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Adam8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adam8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Adam8bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L51"}}),H=new ee({props:{title:"Adam32bit",local:"bitsandbytes.optim.Adam32bit",headingTag:"h2"}}),U=new f({props:{name:"class bitsandbytes.optim.Adam32bit",anchor:"bitsandbytes.optim.Adam32bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L84"}}),R=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Adam32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adam32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Adam32bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L85"}}),j=new ee({props:{title:"PagedAdam",local:"bitsandbytes.optim.PagedAdam",headingTag:"h2"}}),B=new f({props:{name:"class bitsandbytes.optim.PagedAdam",anchor:"bitsandbytes.optim.PagedAdam",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L118"}}),J=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedAdam.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedAdam.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.PagedAdam.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L119"}}),K=new ee({props:{title:"PagedAdam8bit",local:"bitsandbytes.optim.PagedAdam8bit",headingTag:"h2"}}),O=new f({props:{name:"class bitsandbytes.optim.PagedAdam8bit",anchor:"bitsandbytes.optim.PagedAdam8bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L152"}}),Q=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedAdam8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.PagedAdam8bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L153"}}),X=new ee({props:{title:"PagedAdam32bit",local:"bitsandbytes.optim.PagedAdam32bit",headingTag:"h2"}}),Y=new f({props:{name:"class bitsandbytes.optim.PagedAdam32bit",anchor:"bitsandbytes.optim.PagedAdam32bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L186"}}),Z=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedAdam32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-3) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-8) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.amsgrad",description:`<strong>amsgrad</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the <a href="https://hf.co/papers/1904.09237" rel="nofollow">AMSGrad</a> variant of Adam that uses the maximum of past squared gradients instead.`,name:"amsgrad"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.PagedAdam32bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/adam.py#L187"}}),{c(){u=r("meta"),me=i(),re=r("p"),le=i(),m(L.$$.fragment),pe=i(),N=r("p"),N.innerHTML=Ze,ce=i(),W=r("ul"),W.innerHTML=et,be=i(),q=r("p"),q.textContent=tt,_e=i(),m(E.$$.fragment),ge=i(),v=r("div"),m(M.$$.fragment),Se=i(),T=r("div"),m(I.$$.fragment),Ge=i(),te=r("p"),te.textContent=at,he=i(),m(V.$$.fragment),fe=i(),y=r("div"),m(S.$$.fragment),He=i(),P=r("div"),m(G.$$.fragment),Ue=i(),ae=r("p"),ae.textContent=it,ue=i(),m(H.$$.fragment),ve=i(),$=r("div"),m(U.$$.fragment),Re=i(),k=r("div"),m(R.$$.fragment),je=i(),ie=r("p"),ie.textContent=nt,ye=i(),m(j.$$.fragment),$e=i(),A=r("div"),m(B.$$.fragment),Be=i(),F=r("div"),m(J.$$.fragment),Je=i(),ne=r("p"),ne.textContent=st,Ae=i(),m(K.$$.fragment),xe=i(),x=r("div"),m(O.$$.fragment),Ke=i(),D=r("div"),m(Q.$$.fragment),Oe=i(),se=r("p"),se.textContent=ot,we=i(),m(X.$$.fragment),ze=i(),w=r("div"),m(Y.$$.fragment),Qe=i(),C=r("div"),m(Z.$$.fragment),Xe=i(),oe=r("p"),oe.textContent=rt,Te=i(),de=r("p"),this.h()},l(e){const a=bt("svelte-u9bgzb",document.head);u=d(a,"META",{name:!0,content:!0}),a.forEach(t),me=n(e),re=d(e,"P",{}),g(re).forEach(t),le=n(e),l(L.$$.fragment,e),pe=n(e),N=d(e,"P",{"data-svelte-h":!0}),z(N)!=="svelte-et5h9y"&&(N.innerHTML=Ze),ce=n(e),W=d(e,"UL",{"data-svelte-h":!0}),z(W)!=="svelte-1miac0o"&&(W.innerHTML=et),be=n(e),q=d(e,"P",{"data-svelte-h":!0}),z(q)!=="svelte-qpasov"&&(q.textContent=tt),_e=n(e),l(E.$$.fragment,e),ge=n(e),v=d(e,"DIV",{class:!0});var ke=g(v);l(M.$$.fragment,ke),Se=n(ke),T=d(ke,"DIV",{class:!0});var Fe=g(T);l(I.$$.fragment,Fe),Ge=n(Fe),te=d(Fe,"P",{"data-svelte-h":!0}),z(te)!=="svelte-o3b8f9"&&(te.textContent=at),Fe.forEach(t),ke.forEach(t),he=n(e),l(V.$$.fragment,e),fe=n(e),y=d(e,"DIV",{class:!0});var De=g(y);l(S.$$.fragment,De),He=n(De),P=d(De,"DIV",{class:!0});var Ce=g(P);l(G.$$.fragment,Ce),Ue=n(Ce),ae=d(Ce,"P",{"data-svelte-h":!0}),z(ae)!=="svelte-17h2o0s"&&(ae.textContent=it),Ce.forEach(t),De.forEach(t),ue=n(e),l(H.$$.fragment,e),ve=n(e),$=d(e,"DIV",{class:!0});var Le=g($);l(U.$$.fragment,Le),Re=n(Le),k=d(Le,"DIV",{class:!0});var Ne=g(k);l(R.$$.fragment,Ne),je=n(Ne),ie=d(Ne,"P",{"data-svelte-h":!0}),z(ie)!=="svelte-1x8tgev"&&(ie.textContent=nt),Ne.forEach(t),Le.forEach(t),ye=n(e),l(j.$$.fragment,e),$e=n(e),A=d(e,"DIV",{class:!0});var We=g(A);l(B.$$.fragment,We),Be=n(We),F=d(We,"DIV",{class:!0});var qe=g(F);l(J.$$.fragment,qe),Je=n(qe),ne=d(qe,"P",{"data-svelte-h":!0}),z(ne)!=="svelte-1a1nn0n"&&(ne.textContent=st),qe.forEach(t),We.forEach(t),Ae=n(e),l(K.$$.fragment,e),xe=n(e),x=d(e,"DIV",{class:!0});var Ee=g(x);l(O.$$.fragment,Ee),Ke=n(Ee),D=d(Ee,"DIV",{class:!0});var Me=g(D);l(Q.$$.fragment,Me),Oe=n(Me),se=d(Me,"P",{"data-svelte-h":!0}),z(se)!=="svelte-12q2iox"&&(se.textContent=ot),Me.forEach(t),Ee.forEach(t),we=n(e),l(X.$$.fragment,e),ze=n(e),w=d(e,"DIV",{class:!0});var Ie=g(w);l(Y.$$.fragment,Ie),Qe=n(Ie),C=d(Ie,"DIV",{class:!0});var Ve=g(C);l(Z.$$.fragment,Ve),Xe=n(Ve),oe=d(Ve,"P",{"data-svelte-h":!0}),z(oe)!=="svelte-1qxzzie"&&(oe.textContent=rt),Ve.forEach(t),Ie.forEach(t),Te=n(e),de=d(e,"P",{}),g(de).forEach(t),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",gt),h(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){o(document.head,u),s(e,me,a),s(e,re,a),s(e,le,a),p(L,e,a),s(e,pe,a),s(e,N,a),s(e,ce,a),s(e,W,a),s(e,be,a),s(e,q,a),s(e,_e,a),p(E,e,a),s(e,ge,a),s(e,v,a),p(M,v,null),o(v,Se),o(v,T),p(I,T,null),o(T,Ge),o(T,te),s(e,he,a),p(V,e,a),s(e,fe,a),s(e,y,a),p(S,y,null),o(y,He),o(y,P),p(G,P,null),o(P,Ue),o(P,ae),s(e,ue,a),p(H,e,a),s(e,ve,a),s(e,$,a),p(U,$,null),o($,Re),o($,k),p(R,k,null),o(k,je),o(k,ie),s(e,ye,a),p(j,e,a),s(e,$e,a),s(e,A,a),p(B,A,null),o(A,Be),o(A,F),p(J,F,null),o(F,Je),o(F,ne),s(e,Ae,a),p(K,e,a),s(e,xe,a),s(e,x,a),p(O,x,null),o(x,Ke),o(x,D),p(Q,D,null),o(D,Oe),o(D,se),s(e,we,a),p(X,e,a),s(e,ze,a),s(e,w,a),p(Y,w,null),o(w,Qe),o(w,C),p(Z,C,null),o(C,Xe),o(C,oe),s(e,Te,a),s(e,de,a),Pe=!0},p:mt,i(e){Pe||(c(L.$$.fragment,e),c(E.$$.fragment,e),c(M.$$.fragment,e),c(I.$$.fragment,e),c(V.$$.fragment,e),c(S.$$.fragment,e),c(G.$$.fragment,e),c(H.$$.fragment,e),c(U.$$.fragment,e),c(R.$$.fragment,e),c(j.$$.fragment,e),c(B.$$.fragment,e),c(J.$$.fragment,e),c(K.$$.fragment,e),c(O.$$.fragment,e),c(Q.$$.fragment,e),c(X.$$.fragment,e),c(Y.$$.fragment,e),c(Z.$$.fragment,e),Pe=!0)},o(e){b(L.$$.fragment,e),b(E.$$.fragment,e),b(M.$$.fragment,e),b(I.$$.fragment,e),b(V.$$.fragment,e),b(S.$$.fragment,e),b(G.$$.fragment,e),b(H.$$.fragment,e),b(U.$$.fragment,e),b(R.$$.fragment,e),b(j.$$.fragment,e),b(B.$$.fragment,e),b(J.$$.fragment,e),b(K.$$.fragment,e),b(O.$$.fragment,e),b(Q.$$.fragment,e),b(X.$$.fragment,e),b(Y.$$.fragment,e),b(Z.$$.fragment,e),Pe=!1},d(e){e&&(t(me),t(re),t(le),t(pe),t(N),t(ce),t(W),t(be),t(q),t(_e),t(ge),t(v),t(he),t(fe),t(y),t(ue),t(ve),t($),t(ye),t($e),t(A),t(Ae),t(xe),t(x),t(we),t(ze),t(w),t(Te),t(de)),t(u),_(L,e),_(E,e),_(M),_(I),_(V,e),_(S),_(G),_(H,e),_(U),_(R),_(j,e),_(B),_(J),_(K,e),_(O),_(Q),_(X,e),_(Y),_(Z)}}}const gt='{"title":"Adam","local":"adam","sections":[{"title":"Adam","local":"api-class ][ bitsandbytes.optim.Adam","sections":[],"depth":2},{"title":"Adam8bit","local":"bitsandbytes.optim.Adam8bit","sections":[],"depth":2},{"title":"Adam32bit","local":"bitsandbytes.optim.Adam32bit","sections":[],"depth":2},{"title":"PagedAdam","local":"bitsandbytes.optim.PagedAdam","sections":[],"depth":2},{"title":"PagedAdam8bit","local":"bitsandbytes.optim.PagedAdam8bit","sections":[],"depth":2},{"title":"PagedAdam32bit","local":"bitsandbytes.optim.PagedAdam32bit","sections":[],"depth":2}],"depth":1}';function ht(Ye){return lt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class $t extends pt{constructor(u){super(),ct(this,u,ht,_t,dt,{})}}export{$t as component};
