import{s as ut,n as vt,o as ft}from"../chunks/scheduler.0f20f9e5.js";import{S as yt,i as $t,g as s,s as a,r as d,A as xt,h as r,f as e,c as i,j as x,u as l,x as it,k as L,y as m,a as o,v as p,d as c,t as _,w as b}from"../chunks/index.fbd8b8e3.js";import{D as V}from"../chunks/Docstring.8771d8c5.js";import{H as ot}from"../chunks/Heading.2451f3bb.js";function Lt(ct){let g,W,H,q,A,j,S,_t='<a href="https:/hf.co/papers/1708.03888" rel="nofollow">LARS (Layer-wise Adaptive Rate Scaling)</a> is an optimizer designed for training with large batch sizes to accelerate training. LARS uses a separate learning rate for each <em>layer</em> instead of each parameter. The learning rate is calculated from a <em>trust ratio</em> between the weight and gradient norm in a layer. This helps calibrate a stable update size.',B,R,U,h,w,st,f,z,rt,k,bt="Base LARS optimizer.",G,T,J,u,D,mt,y,N,dt,F,gt="8-bit LARS optimizer.",K,C,O,v,E,lt,$,P,pt,I,ht="32-bit LARS optimizer.",Q,M,X;return A=new ot({props:{title:"LARS",local:"lars",headingTag:"h1"}}),R=new ot({props:{title:"LARS",local:"api-class ][ bitsandbytes.optim.LARS",headingTag:"h2"}}),w=new V({props:{name:"class bitsandbytes.optim.LARS",anchor:"bitsandbytes.optim.LARS",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L11"}}),z=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.LARS.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],parametersDescription:[{anchor:"bitsandbytes.optim.LARS.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.LARS.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.LARS.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.LARS.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.LARS.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.LARS.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.LARS.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.LARS.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.LARS.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.LARS.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.LARS.__init__.max_unorm",description:`<strong>max_unorm</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The maximum gradient norm.`,name:"max_unorm"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L12"}}),T=new ot({props:{title:"LARS8bit",local:"bitsandbytes.optim.LARS8bit",headingTag:"h2"}}),D=new V({props:{name:"class bitsandbytes.optim.LARS8bit",anchor:"bitsandbytes.optim.LARS8bit",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L73"}}),N=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.LARS8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],parametersDescription:[{anchor:"bitsandbytes.optim.LARS8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.LARS8bit.__init__.max_unorm",description:`<strong>max_unorm</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The maximum gradient norm.`,name:"max_unorm"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L74"}}),C=new ot({props:{title:"LARS32bit",local:"bitsandbytes.optim.LARS32bit",headingTag:"h2"}}),E=new V({props:{name:"class bitsandbytes.optim.LARS32bit",anchor:"bitsandbytes.optim.LARS32bit",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L132"}}),P=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.LARS32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"max_unorm",val:" = 0.02"}],parametersDescription:[{anchor:"bitsandbytes.optim.LARS32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.LARS32bit.__init__.max_unorm",description:`<strong>max_unorm</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The maximum gradient norm.`,name:"max_unorm"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lars.py#L133"}}),{c(){g=s("meta"),W=a(),H=s("p"),q=a(),d(A.$$.fragment),j=a(),S=s("p"),S.innerHTML=_t,B=a(),d(R.$$.fragment),U=a(),h=s("div"),d(w.$$.fragment),st=a(),f=s("div"),d(z.$$.fragment),rt=a(),k=s("p"),k.textContent=bt,G=a(),d(T.$$.fragment),J=a(),u=s("div"),d(D.$$.fragment),mt=a(),y=s("div"),d(N.$$.fragment),dt=a(),F=s("p"),F.textContent=gt,K=a(),d(C.$$.fragment),O=a(),v=s("div"),d(E.$$.fragment),lt=a(),$=s("div"),d(P.$$.fragment),pt=a(),I=s("p"),I.textContent=ht,Q=a(),M=s("p"),this.h()},l(t){const n=xt("svelte-u9bgzb",document.head);g=r(n,"META",{name:!0,content:!0}),n.forEach(e),W=i(t),H=r(t,"P",{}),x(H).forEach(e),q=i(t),l(A.$$.fragment,t),j=i(t),S=r(t,"P",{"data-svelte-h":!0}),it(S)!=="svelte-18efkb3"&&(S.innerHTML=_t),B=i(t),l(R.$$.fragment,t),U=i(t),h=r(t,"DIV",{class:!0});var Y=x(h);l(w.$$.fragment,Y),st=i(Y),f=r(Y,"DIV",{class:!0});var Z=x(f);l(z.$$.fragment,Z),rt=i(Z),k=r(Z,"P",{"data-svelte-h":!0}),it(k)!=="svelte-1vko6mi"&&(k.textContent=bt),Z.forEach(e),Y.forEach(e),G=i(t),l(T.$$.fragment,t),J=i(t),u=r(t,"DIV",{class:!0});var tt=x(u);l(D.$$.fragment,tt),mt=i(tt),y=r(tt,"DIV",{class:!0});var et=x(y);l(N.$$.fragment,et),dt=i(et),F=r(et,"P",{"data-svelte-h":!0}),it(F)!=="svelte-mgnzq1"&&(F.textContent=gt),et.forEach(e),tt.forEach(e),K=i(t),l(C.$$.fragment,t),O=i(t),v=r(t,"DIV",{class:!0});var nt=x(v);l(E.$$.fragment,nt),lt=i(nt),$=r(nt,"DIV",{class:!0});var at=x($);l(P.$$.fragment,at),pt=i(at),I=r(at,"P",{"data-svelte-h":!0}),it(I)!=="svelte-1l89br0"&&(I.textContent=ht),at.forEach(e),nt.forEach(e),Q=i(t),M=r(t,"P",{}),x(M).forEach(e),this.h()},h(){L(g,"name","hf:doc:metadata"),L(g,"content",At),L(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,n){m(document.head,g),o(t,W,n),o(t,H,n),o(t,q,n),p(A,t,n),o(t,j,n),o(t,S,n),o(t,B,n),p(R,t,n),o(t,U,n),o(t,h,n),p(w,h,null),m(h,st),m(h,f),p(z,f,null),m(f,rt),m(f,k),o(t,G,n),p(T,t,n),o(t,J,n),o(t,u,n),p(D,u,null),m(u,mt),m(u,y),p(N,y,null),m(y,dt),m(y,F),o(t,K,n),p(C,t,n),o(t,O,n),o(t,v,n),p(E,v,null),m(v,lt),m(v,$),p(P,$,null),m($,pt),m($,I),o(t,Q,n),o(t,M,n),X=!0},p:vt,i(t){X||(c(A.$$.fragment,t),c(R.$$.fragment,t),c(w.$$.fragment,t),c(z.$$.fragment,t),c(T.$$.fragment,t),c(D.$$.fragment,t),c(N.$$.fragment,t),c(C.$$.fragment,t),c(E.$$.fragment,t),c(P.$$.fragment,t),X=!0)},o(t){_(A.$$.fragment,t),_(R.$$.fragment,t),_(w.$$.fragment,t),_(z.$$.fragment,t),_(T.$$.fragment,t),_(D.$$.fragment,t),_(N.$$.fragment,t),_(C.$$.fragment,t),_(E.$$.fragment,t),_(P.$$.fragment,t),X=!1},d(t){t&&(e(W),e(H),e(q),e(j),e(S),e(B),e(U),e(h),e(G),e(J),e(u),e(K),e(O),e(v),e(Q),e(M)),e(g),b(A,t),b(R,t),b(w),b(z),b(T,t),b(D),b(N),b(C,t),b(E),b(P)}}}const At='{"title":"LARS","local":"lars","sections":[{"title":"LARS","local":"api-class ][ bitsandbytes.optim.LARS","sections":[],"depth":2},{"title":"LARS8bit","local":"bitsandbytes.optim.LARS8bit","sections":[],"depth":2},{"title":"LARS32bit","local":"bitsandbytes.optim.LARS32bit","sections":[],"depth":2}],"depth":1}';function St(ct){return ft(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dt extends yt{constructor(g){super(),$t(this,g,St,Lt,ut,{})}}export{Dt as component};
