import{s as ie,n as ne,o as ae}from"../chunks/scheduler.0f20f9e5.js";import{S as oe,i as se,g as r,s as n,r as m,A as re,h as d,f as e,c as a,j as g,u as l,x as X,k as h,y as o,a as s,v as p,d as c,t as b,w as _}from"../chunks/index.fbd8b8e3.js";import{D as f}from"../chunks/Docstring.8771d8c5.js";import{H as Y}from"../chunks/Heading.2451f3bb.js";function de(Kt){let u,rt,ot,dt,N,mt,E,Ot='<a href="https://hf.co/papers/2302.06675" rel="nofollow">Lion (Evolved Sign Momentum)</a> is a unique optimizer that uses the sign of the gradient to determine the update direction of the momentum. This makes Lion more memory-efficient and faster than <code>AdamW</code> which tracks and store the first and second-order moments.',lt,A,pt,y,I,qt,z,V,Wt,Z,Qt="Base Lion optimizer.",ct,q,bt,v,W,Ft,T,F,Mt,tt,Xt="8-bit Lion optimizer.",_t,M,gt,$,H,Ht,P,S,St,et,Yt="32-bit Lion optimizer.",ht,j,ft,L,B,jt,k,R,Bt,it,Zt="Paged Lion optimizer.",ut,U,yt,w,G,Rt,D,J,Ut,nt,te="Paged 8-bit Lion optimizer.",vt,K,$t,x,O,Gt,C,Q,Jt,at,ee="Paged 32-bit Lion optimizer.",Lt,st,wt;return N=new Y({props:{title:"Lion",local:"lion",headingTag:"h1"}}),A=new Y({props:{title:"Lion",local:"api-class ][ bitsandbytes.optim.Lion",headingTag:"h2"}}),I=new f({props:{name:"class bitsandbytes.optim.Lion",anchor:"bitsandbytes.optim.Lion",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L8"}}),V=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Lion.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Lion.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Lion.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Lion.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Lion.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Lion.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Lion.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Lion.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Lion.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Lion.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Lion.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L9"}}),q=new Y({props:{title:"Lion8bit",local:"bitsandbytes.optim.Lion8bit",headingTag:"h2"}}),W=new f({props:{name:"class bitsandbytes.optim.Lion8bit",anchor:"bitsandbytes.optim.Lion8bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L37"}}),F=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Lion8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Lion8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Lion8bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L38"}}),M=new Y({props:{title:"Lion32bit",local:"bitsandbytes.optim.Lion32bit",headingTag:"h2"}}),H=new f({props:{name:"class bitsandbytes.optim.Lion32bit",anchor:"bitsandbytes.optim.Lion32bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L64"}}),S=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.Lion32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"},{name:"is_paged",val:" = False"}],parametersDescription:[{anchor:"bitsandbytes.optim.Lion32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"},{anchor:"bitsandbytes.optim.Lion32bit.__init__.is_paged",description:`<strong>is_paged</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the optimizer is a paged optimizer or not.`,name:"is_paged"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L65"}}),j=new Y({props:{title:"PagedLion",local:"bitsandbytes.optim.PagedLion",headingTag:"h2"}}),B=new f({props:{name:"class bitsandbytes.optim.PagedLion",anchor:"bitsandbytes.optim.PagedLion",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L92"}}),R=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedLion.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedLion.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedLion.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedLion.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedLion.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedLion.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedLion.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedLion.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedLion.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedLion.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L93"}}),U=new Y({props:{title:"PagedLion8bit",local:"bitsandbytes.optim.PagedLion8bit",headingTag:"h2"}}),G=new f({props:{name:"class bitsandbytes.optim.PagedLion8bit",anchor:"bitsandbytes.optim.PagedLion8bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L119"}}),J=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedLion8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedLion8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L120"}}),K=new Y({props:{title:"PagedLion32bit",local:"bitsandbytes.optim.PagedLion32bit",headingTag:"h2"}}),O=new f({props:{name:"class bitsandbytes.optim.PagedLion32bit",anchor:"bitsandbytes.optim.PagedLion32bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L146"}}),Q=new f({props:{name:"__init__",anchor:"bitsandbytes.optim.PagedLion32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-4) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.betas",description:`<strong>betas</strong> (<code>tuple(float, float)</code>, defaults to (0.9, 0.999)) &#x2014;
The beta values are the decay rates of the first and second-order moment of the optimizer.`,name:"betas"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.PagedLion32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1041/src/bitsandbytes/optim/lion.py#L147"}}),{c(){u=r("meta"),rt=n(),ot=r("p"),dt=n(),m(N.$$.fragment),mt=n(),E=r("p"),E.innerHTML=Ot,lt=n(),m(A.$$.fragment),pt=n(),y=r("div"),m(I.$$.fragment),qt=n(),z=r("div"),m(V.$$.fragment),Wt=n(),Z=r("p"),Z.textContent=Qt,ct=n(),m(q.$$.fragment),bt=n(),v=r("div"),m(W.$$.fragment),Ft=n(),T=r("div"),m(F.$$.fragment),Mt=n(),tt=r("p"),tt.textContent=Xt,_t=n(),m(M.$$.fragment),gt=n(),$=r("div"),m(H.$$.fragment),Ht=n(),P=r("div"),m(S.$$.fragment),St=n(),et=r("p"),et.textContent=Yt,ht=n(),m(j.$$.fragment),ft=n(),L=r("div"),m(B.$$.fragment),jt=n(),k=r("div"),m(R.$$.fragment),Bt=n(),it=r("p"),it.textContent=Zt,ut=n(),m(U.$$.fragment),yt=n(),w=r("div"),m(G.$$.fragment),Rt=n(),D=r("div"),m(J.$$.fragment),Ut=n(),nt=r("p"),nt.textContent=te,vt=n(),m(K.$$.fragment),$t=n(),x=r("div"),m(O.$$.fragment),Gt=n(),C=r("div"),m(Q.$$.fragment),Jt=n(),at=r("p"),at.textContent=ee,Lt=n(),st=r("p"),this.h()},l(t){const i=re("svelte-u9bgzb",document.head);u=d(i,"META",{name:!0,content:!0}),i.forEach(e),rt=a(t),ot=d(t,"P",{}),g(ot).forEach(e),dt=a(t),l(N.$$.fragment,t),mt=a(t),E=d(t,"P",{"data-svelte-h":!0}),X(E)!=="svelte-1qfxmo"&&(E.innerHTML=Ot),lt=a(t),l(A.$$.fragment,t),pt=a(t),y=d(t,"DIV",{class:!0});var xt=g(y);l(I.$$.fragment,xt),qt=a(xt),z=d(xt,"DIV",{class:!0});var zt=g(z);l(V.$$.fragment,zt),Wt=a(zt),Z=d(zt,"P",{"data-svelte-h":!0}),X(Z)!=="svelte-zbrxqg"&&(Z.textContent=Qt),zt.forEach(e),xt.forEach(e),ct=a(t),l(q.$$.fragment,t),bt=a(t),v=d(t,"DIV",{class:!0});var Tt=g(v);l(W.$$.fragment,Tt),Ft=a(Tt),T=d(Tt,"DIV",{class:!0});var Pt=g(T);l(F.$$.fragment,Pt),Mt=a(Pt),tt=d(Pt,"P",{"data-svelte-h":!0}),X(tt)!=="svelte-1t8hs73"&&(tt.textContent=Xt),Pt.forEach(e),Tt.forEach(e),_t=a(t),l(M.$$.fragment,t),gt=a(t),$=d(t,"DIV",{class:!0});var kt=g($);l(H.$$.fragment,kt),Ht=a(kt),P=d(kt,"DIV",{class:!0});var Dt=g(P);l(S.$$.fragment,Dt),St=a(Dt),et=d(Dt,"P",{"data-svelte-h":!0}),X(et)!=="svelte-xjkt4u"&&(et.textContent=Yt),Dt.forEach(e),kt.forEach(e),ht=a(t),l(j.$$.fragment,t),ft=a(t),L=d(t,"DIV",{class:!0});var Ct=g(L);l(B.$$.fragment,Ct),jt=a(Ct),k=d(Ct,"DIV",{class:!0});var Nt=g(k);l(R.$$.fragment,Nt),Bt=a(Nt),it=d(Nt,"P",{"data-svelte-h":!0}),X(it)!=="svelte-fg4764"&&(it.textContent=Zt),Nt.forEach(e),Ct.forEach(e),ut=a(t),l(U.$$.fragment,t),yt=a(t),w=d(t,"DIV",{class:!0});var Et=g(w);l(G.$$.fragment,Et),Rt=a(Et),D=d(Et,"DIV",{class:!0});var At=g(D);l(J.$$.fragment,At),Ut=a(At),nt=d(At,"P",{"data-svelte-h":!0}),X(nt)!=="svelte-1fu6xri"&&(nt.textContent=te),At.forEach(e),Et.forEach(e),vt=a(t),l(K.$$.fragment,t),$t=a(t),x=d(t,"DIV",{class:!0});var It=g(x);l(O.$$.fragment,It),Gt=a(It),C=d(It,"DIV",{class:!0});var Vt=g(C);l(Q.$$.fragment,Vt),Jt=a(Vt),at=d(Vt,"P",{"data-svelte-h":!0}),X(at)!=="svelte-1pg1i0n"&&(at.textContent=ee),Vt.forEach(e),It.forEach(e),Lt=a(t),st=d(t,"P",{}),g(st).forEach(e),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",me),h(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,i){o(document.head,u),s(t,rt,i),s(t,ot,i),s(t,dt,i),p(N,t,i),s(t,mt,i),s(t,E,i),s(t,lt,i),p(A,t,i),s(t,pt,i),s(t,y,i),p(I,y,null),o(y,qt),o(y,z),p(V,z,null),o(z,Wt),o(z,Z),s(t,ct,i),p(q,t,i),s(t,bt,i),s(t,v,i),p(W,v,null),o(v,Ft),o(v,T),p(F,T,null),o(T,Mt),o(T,tt),s(t,_t,i),p(M,t,i),s(t,gt,i),s(t,$,i),p(H,$,null),o($,Ht),o($,P),p(S,P,null),o(P,St),o(P,et),s(t,ht,i),p(j,t,i),s(t,ft,i),s(t,L,i),p(B,L,null),o(L,jt),o(L,k),p(R,k,null),o(k,Bt),o(k,it),s(t,ut,i),p(U,t,i),s(t,yt,i),s(t,w,i),p(G,w,null),o(w,Rt),o(w,D),p(J,D,null),o(D,Ut),o(D,nt),s(t,vt,i),p(K,t,i),s(t,$t,i),s(t,x,i),p(O,x,null),o(x,Gt),o(x,C),p(Q,C,null),o(C,Jt),o(C,at),s(t,Lt,i),s(t,st,i),wt=!0},p:ne,i(t){wt||(c(N.$$.fragment,t),c(A.$$.fragment,t),c(I.$$.fragment,t),c(V.$$.fragment,t),c(q.$$.fragment,t),c(W.$$.fragment,t),c(F.$$.fragment,t),c(M.$$.fragment,t),c(H.$$.fragment,t),c(S.$$.fragment,t),c(j.$$.fragment,t),c(B.$$.fragment,t),c(R.$$.fragment,t),c(U.$$.fragment,t),c(G.$$.fragment,t),c(J.$$.fragment,t),c(K.$$.fragment,t),c(O.$$.fragment,t),c(Q.$$.fragment,t),wt=!0)},o(t){b(N.$$.fragment,t),b(A.$$.fragment,t),b(I.$$.fragment,t),b(V.$$.fragment,t),b(q.$$.fragment,t),b(W.$$.fragment,t),b(F.$$.fragment,t),b(M.$$.fragment,t),b(H.$$.fragment,t),b(S.$$.fragment,t),b(j.$$.fragment,t),b(B.$$.fragment,t),b(R.$$.fragment,t),b(U.$$.fragment,t),b(G.$$.fragment,t),b(J.$$.fragment,t),b(K.$$.fragment,t),b(O.$$.fragment,t),b(Q.$$.fragment,t),wt=!1},d(t){t&&(e(rt),e(ot),e(dt),e(mt),e(E),e(lt),e(pt),e(y),e(ct),e(bt),e(v),e(_t),e(gt),e($),e(ht),e(ft),e(L),e(ut),e(yt),e(w),e(vt),e($t),e(x),e(Lt),e(st)),e(u),_(N,t),_(A,t),_(I),_(V),_(q,t),_(W),_(F),_(M,t),_(H),_(S),_(j,t),_(B),_(R),_(U,t),_(G),_(J),_(K,t),_(O),_(Q)}}}const me='{"title":"Lion","local":"lion","sections":[{"title":"Lion","local":"api-class ][ bitsandbytes.optim.Lion","sections":[],"depth":2},{"title":"Lion8bit","local":"bitsandbytes.optim.Lion8bit","sections":[],"depth":2},{"title":"Lion32bit","local":"bitsandbytes.optim.Lion32bit","sections":[],"depth":2},{"title":"PagedLion","local":"bitsandbytes.optim.PagedLion","sections":[],"depth":2},{"title":"PagedLion8bit","local":"bitsandbytes.optim.PagedLion8bit","sections":[],"depth":2},{"title":"PagedLion32bit","local":"bitsandbytes.optim.PagedLion32bit","sections":[],"depth":2}],"depth":1}';function le(Kt){return ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ge extends oe{constructor(u){super(),se(this,u,le,de,ie,{})}}export{ge as component};
